REM
REM  Part of the ZilogBoy project
REM  Copyright (C) Mateusz Viste 2010
REM

SUB LoadRomInfos()
  DIM AS STRING TempString
  DIM AS INTEGER x

  TempString = CHR(MemoryROM(&h134),MemoryROM(&h135),MemoryROM(&h136),MemoryROM(&h137),_
                   MemoryROM(&h138),MemoryROM(&h139),MemoryROM(&h13A),MemoryROM(&h13B),_
                   MemoryROM(&h13C),MemoryROM(&h13D),MemoryROM(&h13E),MemoryROM(&h13F),_
                   MemoryROM(&h140),MemoryROM(&h141),MemoryROM(&h142),MemoryROM(&h143))
  x = 0
  WHILE ASC(MID(TempString, x + 1, 1)) > 0 AND x < 16
    x += 1
  WEND
  TempString = MID(TempString, 1, x)  ' Trim all zeroed bytes at the end
  RomInfos.Title = TempString

  IF MemoryROM(&h14B) = &h33 THEN  ' New-style license
      SELECT CASE (MemoryROM(&h144) AND &b11110000) OR (MemoryROM(&h145) AND &b00001111)
        CASE ELSE
          RomInfos.Licensee = "unknown [" & HEX(MemoryROM(&h144)) & "-" & HEX(MemoryROM(&h145)) & "]"
      END SELECT
    ELSE  ' Old style license
      SELECT CASE MemoryROM(&h14B)  ' Get licensee code from 014Bh
        CASE &h00
          RomInfos.Licensee = "none"
        CASE &h01
          RomInfos.Licensee = "Nintendo"
        CASE &h08
          RomInfos.Licensee = "Capcom"
        CASE &h09
          RomInfos.Licensee = "HOT-B"
        CASE &h0A
          RomInfos.Licensee = "Jaleco"
        CASE &h0B
          RomInfos.Licensee = "Coconuts"
        CASE &h0C
          RomInfos.Licensee = "Elite Systems"
        CASE &h13
          RomInfos.Licensee = "Electronic Arts"
        CASE &h18
          RomInfos.Licensee = "Hudson Soft"
        CASE &h19
          RomInfos.Licensee = "ITC Entertainment"
        CASE &h1A
          RomInfos.Licensee = "Yanoman"
        CASE &h1D
          RomInfos.Licensee = "Clary"
        CASE &h1F
          RomInfos.Licensee = "Virgin"
        CASE &h24
          RomInfos.Licensee = "PCM Complete"
        CASE &h25
          RomInfos.Licensee = "San-X"
        CASE &h28
          RomInfos.Licensee = "Kotobuki Systems"
        CASE &h29
          RomInfos.Licensee = "Seta"
        CASE &h30
          RomInfos.Licensee = "Infogrames"
        CASE &h31
          RomInfos.Licensee = "Nintendo"
        CASE &h32
          RomInfos.Licensee = "Bandai"
        CASE &h34
          RomInfos.Licensee = "Konami"
        CASE &h35
          RomInfos.Licensee = "Hector"
        CASE &h38
          RomInfos.Licensee = "Capcom"
        CASE &h39
          RomInfos.Licensee = "Banpresto"
        CASE &h3C
          RomInfos.Licensee = "Entertainment I (?)"
        CASE &h3E
          RomInfos.Licensee = "Gremlin"
        CASE &h41
          RomInfos.Licensee = "Ubi Soft"
        CASE &h42
          RomInfos.Licensee = "Atlus"
        CASE &h44
          RomInfos.Licensee = "Malibu"
        CASE &h46
          RomInfos.Licensee = "Angel"
        CASE &h47
          RomInfos.Licensee = "Spectrum Holoby"
        CASE &h49
          RomInfos.Licensee = "Irem"
        CASE &h4A
          RomInfos.Licensee = "Virgin"
        CASE &h4D
          RomInfos.Licensee = "Malibu"
        CASE &h4F
          RomInfos.Licensee = "U.S. Gold"
        CASE &h50
          RomInfos.Licensee = "Absolute"
        CASE &h51
          RomInfos.Licensee = "Acclaim"
        CASE &h52
          RomInfos.Licensee = "Activision"
        CASE &h53
          RomInfos.Licensee = "American Sammy"
        CASE &h54
          RomInfos.Licensee = "Gametek"
        CASE &h55
          RomInfos.Licensee = "Park Place"
        CASE &h56
          RomInfos.Licensee = "LJN"
        CASE &h57
          RomInfos.Licensee = "Matchbox"
        CASE &h59
          RomInfos.Licensee = "Milton Bradley"
        CASE &h5A
          RomInfos.Licensee = "Mindscape"
        CASE &h5B
          RomInfos.Licensee = "Romstar"
        CASE &h5C
          RomInfos.Licensee = "Naxat Soft"
        CASE &h5D
          RomInfos.Licensee = "Tradewest"
        CASE &h60
          RomInfos.Licensee = "Titus"
        CASE &h61
          RomInfos.Licensee = "Virgin"
        CASE &h67
          RomInfos.Licensee = "Ocean"
        CASE &h69
          RomInfos.Licensee = "Electronic Arts"
        CASE &h6E
          RomInfos.Licensee = "Elite Systems"
        CASE &h6F
          RomInfos.Licensee = "Electro Brain"
        CASE &h70
          RomInfos.Licensee = "Infogrames"
        CASE &h71
          RomInfos.Licensee = "Interplay"
        CASE &h72
          RomInfos.Licensee = "Broderbund"
        CASE &h73
          RomInfos.Licensee = "Sculptered Soft"
        CASE &h75
          RomInfos.Licensee = "The Sales Curve"
        CASE &h78
          RomInfos.Licensee = "T*HQ"
        CASE &h79
          RomInfos.Licensee = "Accolade"
        CASE &h7A
          RomInfos.Licensee = "Triffix Entertainment"
        CASE &h7C
          RomInfos.Licensee = "Microprose"
        CASE &h7F
          RomInfos.Licensee = "Kemco"
        CASE &h80
          RomInfos.Licensee = "Misawa Entertainment"
        CASE &h83
          RomInfos.Licensee = "Lozc"
        CASE &h86
          RomInfos.Licensee = "Tokuma Shoten I (?)"
        CASE &h8B
          RomInfos.Licensee = "Bullet-Proof Software"
        CASE &h8C
          RomInfos.Licensee = "Vic Tokai"
        CASE &h8E
          RomInfos.Licensee = "Ape"
        CASE &h8F
          RomInfos.Licensee = "I'Max"
        CASE &h91
          RomInfos.Licensee = "Chun Soft"
        CASE &h92
          RomInfos.Licensee = "Video System"
        CASE &h93
          RomInfos.Licensee = "Tsuburava"
        CASE &h95
          RomInfos.Licensee = "Varie"
        CASE &h96
          RomInfos.Licensee = "Yonezawa/s'pal"
        CASE &h97
          RomInfos.Licensee = "Kaneko"
        CASE &h99
          RomInfos.Licensee = "Arc"
        CASE &h9A
          RomInfos.Licensee = "Nihon Bussan"
        CASE &h9B
          RomInfos.Licensee = "Tecmo"
        CASE &h9C
          RomInfos.Licensee = "Imagineer"
        CASE &h9D
          RomInfos.Licensee = "Banpresto"
        CASE &h9F
          RomInfos.Licensee = "Nova"
        CASE &hA1
          RomInfos.Licensee = "Hori Electric"
        CASE &hA2
          RomInfos.Licensee = "Bandai"
        CASE &hA4
          RomInfos.Licensee = "Konami"
        CASE &hA6
          RomInfos.Licensee = "Kawada"
        CASE &hA7
          RomInfos.Licensee = "Takara"
        CASE &hA9
          RomInfos.Licensee = "Technos Japan"
        CASE &hAA
          RomInfos.Licensee = "Broderbund"
        CASE &hAC
          RomInfos.Licensee = "Toei Animation"
        CASE &hAD
          RomInfos.Licensee = "Toho"
        CASE &hAF
          RomInfos.Licensee = "Namco"
        CASE &hB0
          RomInfos.Licensee = "Acclaim"
        CASE &hB1
          RomInfos.Licensee = "Ascii / Nexoft"
        CASE &hB2
          RomInfos.Licensee = "Bandai"
        CASE &hB4
          RomInfos.Licensee = "Enix"
        CASE &hB6
          RomInfos.Licensee = "Hal"
        CASE &hB7
          RomInfos.Licensee = "SNK"
        CASE &hB9
          RomInfos.Licensee = "Pony Canyon"
        CASE &hBA
          RomInfos.Licensee = "Culture Brain O (?)"
        CASE &hBB
          RomInfos.Licensee = "Sunsoft"
        CASE &hBD
          RomInfos.Licensee = "Sony Imagesoft"
        CASE &hBF
          RomInfos.Licensee = "Sammy"
        CASE &hC0
          RomInfos.Licensee = "Taito"
        CASE &hC2
          RomInfos.Licensee = "Kemco"
        CASE &hC3
          RomInfos.Licensee = "Squaresoft"
        CASE &hC4
          RomInfos.Licensee = "Tokuma Shoten I (?)"
        CASE &hC5
          RomInfos.Licensee = "Data East"
        CASE &hC6
          RomInfos.Licensee = "Tonkin House"
        CASE &hC8
          RomInfos.Licensee = "Koei"
        CASE &hC9
          RomInfos.Licensee = "UFL"
        CASE &hCA
          RomInfos.Licensee = "Ultra"
        CASE &hCB
          RomInfos.Licensee = "Vap"
        CASE &hCC
          RomInfos.Licensee = "Use"
        CASE &hCD
          RomInfos.Licensee = "Meldac"
        CASE &hCE
          RomInfos.Licensee = "Pony Canyon Or (?)"
        CASE &hCF
          RomInfos.Licensee = "Angel"
        CASE &hD0
          RomInfos.Licensee = "Taito"
        CASE &hD1
          RomInfos.Licensee = "Sofel"
        CASE &hD2
          RomInfos.Licensee = "Quest"
        CASE &hD3
          RomInfos.Licensee = "Sigma Enterprises"
        CASE &hD4
          RomInfos.Licensee = "Ask Kodansha"
        CASE &hD6
          RomInfos.Licensee = "Naxat Soft"
        CASE &hD7
          RomInfos.Licensee = "Copya Systems"
        CASE &hD9
          RomInfos.Licensee = "Banpresto"
        CASE &hDA
          RomInfos.Licensee = "Tomy"
        CASE &hDB
          RomInfos.Licensee = "LJN"
        CASE &hDD
          RomInfos.Licensee = "NCS"
        CASE &hDE
          RomInfos.Licensee = "Human"
        CASE &hDF
          RomInfos.Licensee = "Altron"
        CASE &hE0
          RomInfos.Licensee = "Jaleco"
        CASE &hE1
          RomInfos.Licensee = "Towachiki"
        CASE &hE2
          RomInfos.Licensee = "Uutaka"
        CASE &hE3
          RomInfos.Licensee = "Varie"
        CASE &hE5
          RomInfos.Licensee = "Epoch"
        CASE &hE7
          RomInfos.Licensee = "Athena"
        CASE &hE8
          RomInfos.Licensee = "Asmik"
        CASE &hE9
          RomInfos.Licensee = "Natsume"
        CASE &hEA
          RomInfos.Licensee = "King Records"
        CASE &hEB
          RomInfos.Licensee = "Atlus"
        CASE &hEC
          RomInfos.Licensee = "Epic / Sony Records"
        CASE &hEE
          RomInfos.Licensee = "IGS"
        CASE &hF0
          RomInfos.Licensee = "A Wave"
        CASE &hF3
          RomInfos.Licensee = "Extreme Entertainment"
        CASE &hFF
          RomInfos.Licensee = "LJN"
        CASE ELSE
          RomInfos.Licensee = "unknown [" & HEX(MemoryROM(&h14B), 2) & "h]"
      END SELECT
  END IF

  IF MemoryROM(&h143) = &h80 THEN RomInfos.ColorGB = 1
  IF MemoryROM(&h146) = &h03 THEN RomInfos.SuperGB = 1
  RomInfos.CartType = CartTypes(MemoryROM(&h147))

  SELECT CASE MemoryROM(&h148)
    CASE &h00 ' 256 Kbit
      RomInfos.RomSize = 32768
    CASE &h01 ' 512 Kbit
      RomInfos.RomSize = 65536
    CASE &h02 ' 1 Mbit
      RomInfos.RomSize = 131072
    CASE &h03 ' 2 Mbit
      RomInfos.RomSize = 262144
    CASE &h04 ' 4 Mbit
      RomInfos.RomSize = 524288
    CASE &h05 ' 8 Mbit
      RomInfos.RomSize = 1048576
    CASE &h06 ' 16 Mbit
      RomInfos.RomSize = 2097152
    CASE &h52 ' 9 Mbit
      RomInfos.RomSize = 1179648
    CASE &h53 ' 10 Mbit
      RomInfos.RomSize = 1310720
    CASE &h54 ' 12 Mbit
      RomInfos.RomSize = 1572864
  END SELECT

  SELECT CASE MemoryROM(&h149)
    CASE 0 ' no RAM
      RomInfos.RamSize = 0
    CASE 1 ' 16 kBit
      RomInfos.RamSize = 2048
    CASE 2 ' 64 kBit
      RomInfos.RamSize = 8192
    CASE 3 ' 256 kBit
      RomInfos.RamSize = 32768
    CASE 4 ' 1 MBit
      RomInfos.RamSize = 131072
  END SELECT

  IF MemoryROM(&h14A) = 0 THEN RomInfos.Destination = 0 ELSE RomInfos.Destination = 1

END SUB
